<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta http-equiv="X-UA-Compatible" content="ie=edge">
    <title>rem:动态实现</title>
    <style>
        html{
            font-size: 62.5%;
            margin: 20px;
            color: #0072e4;
            font-weight: bold;
        }
        .wrap{
            font-size: 1.2rem;
        }
        .wrap-div1{
            font-size: 1.2rem;
        }
        .wrap-div2{
            font-size: 1.2rem;
        }
    </style>
</head>
<body>
    <div class="wrap">
        <p>效果1</p>
        <div class="wrap-div1">
            <p>效果2</p>
            <div class="wrap-div2">
                <p>效果3</p>
            </div>
        </div>
    </div>
</body>
    <script>
        (function() {
            var ua = window.navigator.userAgent;
            var docEl = document.documentElement;
            var html = document.querySelector('html');
            var isAndorid = /Android/i.test(ua);
            var dpr = window.devicePixelRatio || 1;
            var rem = docEl.clientWidth / 10;

            // 设置 rem 基准值
            html.style.fontSize = rem + 'px';

            // Nexus 5 上 rem 值不准，
            // 如：设置100px，getComputedStyle 中的值却为 85px，导致页面错乱
            // 这时需要检查设置的值和计算后的值是否一样，
            // 不一样的话重新设置正确的值
            var getCPTStyle = window.getComputedStyle;
            var fontSize = parseFloat(html.style.fontSize, 10);
            var computedFontSize = parseFloat(getCPTStyle(html)['font-size'], 10);
            if (getCPTStyle && Math.abs(fontSize - computedFontSize) >= 1) {
                html.style.fontSize = fontSize * (fontSize / computedFontSize) + 'px';
            }

            // 设置 data-dpr 属性，留作的 css hack 之用
            html.setAttribute('data-dpr', dpr);

            // 安卓平台额外加上标记类
            if (isAndorid) {
                html.setAttribute('data-platform', 'android');
            }
        })();
    </script>
</html>